﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win;
using System.Globalization;

namespace PhoneMask
{
    public partial class Form1 : Form
    {
        DataTable _data;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            CreateData();
            this.ultraGrid1.DataSource = _data;
        }

        private void CreateData()
        {
            _data = new DataTable("Test");
            _data.Columns.Add("PhoneNo", typeof(string));
            DataRow row = _data.NewRow();
            row["PhoneNo"] = "9491112222";
            _data.Rows.Add(row);
            row = _data.NewRow();
            row["PhoneNo"] = "9492223333";
            _data.Rows.Add(row);
            row = _data.NewRow();
            row["PhoneNo"] = "9493334444";
            _data.Rows.Add(row);
            row = _data.NewRow();
            row["PhoneNo"] = "9494445555";
            _data.Rows.Add(row);
            row = _data.NewRow();
            row["PhoneNo"] = "9495556666";
            _data.Rows.Add(row);
            row = _data.NewRow();
            row["PhoneNo"] = "9496667777";
            _data.Rows.Add(row);
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            this.ultraGrid1.DisplayLayout.Bands[0].Columns["PhoneNo"].Editor.DataFilter = new StringDataFilter("(@@@) @@@-@@@@");
        }
    }

    public class StringDataFilter : Infragistics.Win.IEditorDataFilter
    {

        public StringDataFilter(string MyFormatString)
        {
            this.myFormatString = MyFormatString;
        }

        private string myFormatString;
        public string MyFormatString
        {
            get { return myFormatString; }
            set { myFormatString = value; }
        }

        object Infragistics.Win.IEditorDataFilter.Convert(Infragistics.Win.EditorDataFilterConvertArgs args)
        {
           string formattedString;
            switch (args.Direction)
            {
                case ConversionDirection.EditorToOwner:
                case ConversionDirection.EditorToDisplay:
                   
                    if (args.Value == null)
                        formattedString = string.Empty;
                    if (myFormatString == null)
                        formattedString = string.Format("{0}", args.Value);
                    else if (args.Value is IFormattable)
                    {
                        formattedString = ((IFormattable)args.Value).ToString(myFormatString, System.Globalization.CultureInfo.CurrentCulture);
                    }
                    else if (args.Value is string)
                    {
                        char[] argChar = args.Value.ToString().ToCharArray();
                        System.Text.StringBuilder returnValue = new System.Text.StringBuilder(myFormatString.Length);
                        int argIndex = 0;
                        foreach (char f in myFormatString)
                        {
                            if (f == '@')
                            {
                                if (argIndex < argChar.Length)
                                {
                                    returnValue.Append(argChar[argIndex]);
                                    argIndex++;
                                }
                                else
                                    returnValue.Append(' ');
                            }
                            else
                                returnValue.Append(f);
                        }
                        formattedString = returnValue.ToString();
                    }
                    else
                        formattedString = args.Value.ToString();
                    args.Handled = true;
                    return formattedString;
            }
            return null;
        }
    }
}
